import java.util.ArrayList;

public class Controller{
  private static Controller controller=null;
  public static Controller gibController(){
    if (controller==null) controller=new Controller();
    return controller;
  }
  public static void beenden(){
    Leinwand.gibLeinwand().setzeSichtbarkeit(false);
  }
  // Instanzen:
  private ArrayList<Moebel> moebel=null;
  private int ausgewaehlt;
  private Controller(){
    moebel=new ArrayList();
    ausgewaehlt=-1;
  }
  
  private Moebel ausgewaehltes(){
    if (ausgewaehlt<0) return null;
    if (ausgewaehlt>=moebel.size()) return null;
    else return moebel.get(ausgewaehlt);
  }
  
  public String neu(String typ){
    Moebel neu=null;
    if (typ.equals("Stuhl")) neu=new Stuhl();
    else if (typ.equals("Tisch")) neu=new Tisch();
    else if (typ.equals("Sessel")) neu=new Sessel();
    else if (typ.equals("Bett")) neu=new Bett();
    else if (typ.equals("Schrank")) neu=new Schrank();
    else if (typ.equals("Schrankwand")) neu=new Schrankwand(3);
    else return "keines";
    moebel.add(neu);
    neu.zeige();
    ausgewaehlt=moebel.size()-1;
    return ausgewaehltes().getClass().getName();
  }
  
  public void waagerecht(String inhalt){
     int weite=StringToInt(inhalt);
     if (ausgewaehltes()!=null) ausgewaehltes().bewegeHorizontal(weite);
  }
  public void senkrecht(String inhalt){
     int weite=StringToInt(inhalt);
     if (ausgewaehltes()!=null) ausgewaehltes().bewegeVertikal(weite);
  }
  public void drehe(String inhalt){
     int winkel=StringToInt(inhalt);
     if (ausgewaehltes()!=null) ausgewaehltes().dreheAuf(winkel);
  }
  public void aendereFarbe(String farbe){
    if (ausgewaehltes()!=null) ausgewaehltes().aendereFarbe(farbe);
  }
  public String voriges(){
    String aktuell="keines";
    if (moebel.size()>0) {
      ausgewaehlt--;
      if (ausgewaehlt<0) ausgewaehlt=moebel.size()-1;
      aktuell=ausgewaehltes().getClass().getName();
    }
    return aktuell;
  }
  public String naechstes(){
    String aktuell="keines";
    if (moebel.size()>0) {
      ausgewaehlt++;
      if (ausgewaehlt>=moebel.size()) ausgewaehlt=0;
      aktuell=ausgewaehltes().getClass().getName();
    }
    return aktuell;
  }
  
  public void loeschen(){
     if (ausgewaehlt>=0) {
       ausgewaehltes().verberge();
       moebel.remove(ausgewaehltes());
       if (moebel.size()==0) ausgewaehlt=-1;
       else if (ausgewaehlt>=moebel.size()) ausgewaehlt=0;
     }
  }
  
  /**
   * Maussteuerung
   */
  private int xMaus=0;
  private int yMaus=0;  // sichert die letzte Mausposition
  public void mausposition(int x,int y){
    if (moebel.size()==0) return;
    for (int i=0; i<moebel.size();i++)
    if ((x>moebel.get(i).gibUmriss().getBounds2D().getX())
         && (x<moebel.get(i).gibUmriss().getBounds2D().getMaxX())
         && (y>moebel.get(i).gibUmriss().getBounds2D().getY())
         && (y<moebel.get(i).gibUmriss().getBounds2D().getMaxY())){
       ausgewaehlt=i;
       xMaus=x;
       yMaus=y;
    }
  }
  public void angeklickt(int x, int y){
    if (moebel.size()==0) return;
    for (int i=0; i<moebel.size();i++)
    if ((x>moebel.get(i).gibUmriss().getBounds2D().getX())
         && (x<moebel.get(i).gibUmriss().getBounds2D().getMaxX())
         && (y>moebel.get(i).gibUmriss().getBounds2D().getY())
         && (y<moebel.get(i).gibUmriss().getBounds2D().getMaxY())){
       ausgewaehlt=i;
       xMaus=0;
       yMaus=0;
    }
  }
  
  public void verschiebeAuf(int x, int y){
    ausgewaehltes().bewegeHorizontal(x-xMaus);
    ausgewaehltes().bewegeVertikal(y-yMaus);
    xMaus=x;
    yMaus=y;
  }
  
  /**
   * Hilfsmethode zum Konvertieren
   */
  public int StringToInt(String inhalt) {
    int wert=0;
    try {
      wert=Integer.parseInt(inhalt);
    } catch (NumberFormatException e){
       // wert bleibt 0
    }
    return wert;
  }
}
